
{$APPTYPE GUI}{$MODE DELPHI}

program Demo27;

uses
  SysUtils,windows,math,gl,glu,GraphOGL;

//const
 
//type
  
var 
  i:integer;
  Angle:glfloat;
  Anim:TGLFX_3DAnimation;  
  
//{$i *.inc} // se abilitato cosente di caricare i comandi che risiedono nei file INC
      
//{$R sound.rc}
//{$R sound.res} 
//{$R *.res}  


procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tsize:glFloat);
begin
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1*tsize,1*tsize, 0,1*tsize, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1*tsize,0, x3,y3,z3, x4,y4,z4,true);	  
  glEnd;
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
	
  TextureLoadID('stoneblocks.bmp',0);	  
  TextureLoadID('fuoco8.bmp',1);
  TextureLoadTGAID('rete00_1.tga',0);	
  
end;
begin 

  OpenGL_Texture();	  	    
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);               // inizializza la grafica 2D 
  
  SetPosXY(0,0);                     // consente di corregge lo zero della grafica 2D   
   
  
  OpenGL_Init(100,0,119/300,187/300,255/300);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
 
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-8,-60);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0); 
  SetglMouseMove(GL_M0,2);  
  glRotatef(45,0,1,0);            // regola l'inquadratura di n gradi rispetto agli assi x y z      
  
  PutglPointLight(GL_LIGHT0,0,0,10,0,0.1);     

  // terreno
  TextureSelectID(0); 
  Quad(-20,-2.5,-20, 20,-2.5,-20, -20,-2.5,20, 20,-2.5,20, 3); 
  
  // gabbia
  TwoSideON;
  glDisable(GL_CULL_FACE);
  
  SetglSprite;
  TextureTGASelectID(0);  
  Cubo(0,-2.3,0, -12,0,-12, 12,24,12, 3);
  
  glEnable(GL_CULL_FACE);  
  TwoSideOFF;
  
  // fuoco
  TextureSelectID(1);
  glPushMatrix;
  glTranslatef(0,17,0);
  for i:=0 to 8 do 
  begin
   Angle:=2*pi*i/8;
   
   glRotatef(RadToDeg(Angle),0,1,0);  
   FX_3DAnimation(Anim,0,0,0,10,20,8,1,1/8,false,false,true,true);     
  end;
  glPopMatrix;
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Gabbia creata con texture sprite', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,119/300,187/300,255/300);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
